<template>
  <form
    autocomplete="off"
    class="bg-primary-500 bg-opacity-30 rounded border border-primary-600 flex flex-col space-y-2 p-2 items-center"
    @submit.stop.prevent="login"
  >
    <h1 class="text-xl font-extrabold">WG-Reports</h1>
    <BaseInput
      v-model="user.email"
      type="email"
      class="w-full"
      placeholder="E-mail"
      required
    />
    <BaseInput
      v-model="user.password"
      type="password"
      class="w-full"
      placeholder="Senha"
      required
    />
    <BaseButton
      type="submit"
      label="Login"
      class="bg-blue-500 bg-opacity-30 rounded border border-blue-600"
    >
      <LoginIcon class="h-5 w-5" />
    </BaseButton>
  </form>
</template>

<script>
import { LoginIcon } from '@vue-hero-icons/outline'
import User from '~/classes/User'
import BaseInput from '~/components/ui/BaseInput.vue'
import BaseButton from '~/components/ui/BaseButton.vue'
export default {
  name: 'LoginView',
  components: {
    BaseButton,
    LoginIcon,
    BaseInput,
  },
  data() {
    return {
      user: {
        email: '',
        password: '',
      },
    }
  },
  methods: {
    async login() {
      try {
        await this.$axios.$post('login', { ...this.user }).then((response) => {
          if (response.status.is_error) {
            this.$toast.info(
              'Dados de login incorretos ou usuário não cadastrado, contate um adminitrador.',
              {
                closeOnSwipe: true,
                duration: 4000,
              }
            )
            return
          }
          const user = new User({ ...response?.data?.user })
          this.$toast.success(`Bem vindo/a ${user.name}!`, {
            closeOnSwipe: true,
            duration: 2000,
          })
          this.$auth
            .loginWith('AuthLogin', {
              userInfo: user,
              token: response?.data?.token?.bearer,
            })
            .then(() => {
              this.$router.push('/home')
            })
        })
      } catch (error) {
        // eslint-disable-next-line no-console
        console.warn(error)
        this.$toast.error('Ocorreu um erro inesperado...', {
          closeOnSwipe: true,
          duration: 2000,
        })
      }
    },
  },
}
</script>
